﻿var KeyHandler = {
    MainMenuAnchor : null,
    LivePlayerAnchor : null,
	NumberEntered : '',
	ChSelectorTimeout : null,
	Selectbox : null,
	info_focus : false,
	BrowserAnchor : null,
	VideothekPlayerAnchor : null,
	black_line : false,

}

KeyHandler.create = function() {
    this.MainMenuAnchor  =  document.getElementById("MainMenu_Anchor");
    this.LivePlayerAnchor  =  document.getElementById("LivePlayer_Anchor");    
	this.SelectboxAnchor = document.getElementById("Selectbox_Anchor");
	this.BrowserAnchor = document.getElementById("Browser_Anchor");
	this.VideothekPlayerAnchor = document.getElementById("VideothekPlayer_Anchor");
}

KeyHandler.setFocus = function(menuID) {  
	ConsoleLog('KeyHandler.setFocus ' + menuID);
    switch(menuID)
    {
		case Main.MainMenu_ID:
			this.MainMenuAnchor.focus();
			break;
		case Main.LivePlayer_ID:
			this.LivePlayerAnchor.focus();
			break;
		case Main.Selectbox_ID:
			this.SelectboxAnchor.focus();
			break;		
		case Main.Browser_ID:
			this.BrowserAnchor.focus();
			break;		
		case Main.VideothekPlayer_ID:
			this.VideothekPlayerAnchor.focus();
			break;			
		default:
		  alert("Unhandled key");
    }    
}

/*
650 TXT MIX
259 PREV CH
Dual: 655
AD: 0
SUB: 652
GUID 651
*/

KeyHandler.KanalSelector = function() 
{
	alert('KeyHandler.KanalSelector');
	var max = API.chan_counter;
	if(KeyHandler.NumberEntered>max)
	{
		Display.status('ошибка ввода');
	}
	else if (KeyHandler.NumberEntered > 0)
	{
		if(KeyHandler.NumberEntered < 11)
			Main.selected_channel = KeyHandler.NumberEntered - 1;
		else if((KeyHandler.NumberEntered % 10)>0)
			Main.selected_channel = (KeyHandler.NumberEntered % 10) - 1;
		else
			Main.selected_channel =  9;
					
		if (Main.selected_channel < 4)
			Main.selected_page = Math.round(KeyHandler.NumberEntered / 10);
		else
			Main.selected_page = Math.round(KeyHandler.NumberEntered / 10) - 1;
			
		Main.chan_array_index = parseInt(KeyHandler.NumberEntered - 1);
		Main.ch_id_selected = API.channels[Main.chan_array_index][0];
		
		KeyHandler.NumberEntered = '';
		Main.updatePage();
		Main.updateChannel();
		Main.PlayChannel();
		
	}

	KeyHandler.NumberEntered = '';
}

KeyHandler.Keys10 = function(keyCode)
{
	var number="";
	clearTimeout(Player.kinozal_live_reloader);
	switch(keyCode)
    {    
		case tvKey.KEY_1:
			number="1";
            break;
		case tvKey.KEY_2:
			number="2";
            break;
		case tvKey.KEY_3:
			number="3";
            break;
		case tvKey.KEY_4:
			number="4";
            break;
		case tvKey.KEY_5:
			number="5";
            break;
		case tvKey.KEY_6:
			number="6";
            break;
		case tvKey.KEY_7:
			number="7";
            break;
		case tvKey.KEY_8:
			number="8";
            break;
		case tvKey.KEY_9:
			number="9";
            break;
		case tvKey.KEY_0:
			number="0";
            break;		
		default:
            alert("Unhandled key");
            break;
	}
	
	KeyHandler.NumberEntered = KeyHandler.NumberEntered + number;
	if(number!="" && KeyHandler.NumberEntered != "")
	{
		Display.status(KeyHandler.NumberEntered);
		if(	Main.StreamMode == "rtmp")
		{
			Main.player.info(KeyHandler.NumberEntered);
		}
		clearTimeout(this.ChSelectorTimeout);
		this.ChSelectorTimeout = setTimeout("KeyHandler.KanalSelector();", 2000);
	}

}
	
KeyHandler.MainMenuKeyDown = function()
{
    var keyCode0 = event.keyCode;
	alert(" MainMenuKeyDown Key pressed: " + keyCode0);
	//Display.status("BUTTON-ID: " + keyCode0);
	
	switch(keyCode0)
    {    
		case tvKey.KEY_REC:
			document.getElementById("statusbar").style.display="block";
			widgetAPI.putInnerHTML(document.getElementById("status"), '<br><br>'+Main.mac_md5);
			break;
			
		case tvKey.KEY_EXIT:
			widgetAPI.blockNavigation(event);
			Player.plugin.Stop();
			widgetAPI.sendReturnEvent();
            break;    
            break;

	    case tvKey.KEY_RETURN:
			widgetAPI.blockNavigation(event);
            if(Player.state == Player.PLAYING_LIVE)
			{
				Main.selected_channel = Player.selected_channel;
				Main.selected_page = Player.selected_page;
				Main.chan_array_index = Player.chan_array_index;
				Main.UpdatePlayerStatusbar();
				KeyHandler.setFocus(Main.LivePlayer_ID);
				Display.showplayer();
				Display.hidemenu();
			} 		
            if(Player.state == Player.PLAYING_VOD)
			{
				Main.selected_channel = Player.selected_channel;
				Main.selected_page = Player.selected_page;
				Main.chan_array_index = Player.chan_array_index;
				Main.UpdatePlayerStatusbar();
				KeyHandler.setFocus(Main.VideothekPlayer_ID);
				Display.showplayer();
				Display.hidemenu();
			} 		
            break;
			
		 case tvKey.KEY_DOWN:
            Main.selectNextChannel();
            break;
            
        case tvKey.KEY_UP:
            Main.selectPrevChannel();
            break;            

		case tvKey.KEY_LEFT:
            Main.selectPrevPage();
            break;
            
        case tvKey.KEY_RIGHT:
            Main.selectNextPage();
            break;
			
        case tvKey.KEY_ENTER:			
			Main.PlayChannel();
            break;
	
        case tvKey.KEY_VOL_UP:
            Audio.setRelativeVolume(0);
			Display.setVolume();
            break;
            
        case tvKey.KEY_VOL_DOWN:
            Audio.setRelativeVolume(1);
			Display.setVolume();
            break; 

		case tvKey.KEY_GREEN:
            pluginAPI.ShowTools(1);
            break;
 
		case tvKey.KEY_YELLOW:
			pluginAPI.ShowTools(0);
            break;

		case tvKey.KEY_MUTE:
			Audio.muteMode();
            break;	

		case tvKey.KEY_TOOLS: //Menu
            Setup.setFormular();
            break;

        case tvKey.KEY_RED:
		if(API.categories.length>0)
		{
			Selectbox.mode = 0;
			Main.showCategorySelector();
		}
		else
			Display.status('CATEGORIES NOT FOUND');
			break;
			
		case tvKey.KEY_INFO:
			KeyHandler.setFocus(Main.Browser_ID);			
			var browser = document.getElementById("browser");
			widgetAPI.putInnerHTML(browser, '<iframe id="website_url" src="dummy.html"></iframe>');
			browser.style.display="block";
			document.getElementById("main").style.display="none";
			document.getElementById('website_url').src=Main.browser_url;
			//document.getElementById('website_url').focus();
			break;
			
        /*
		case tvKey.KEY_PLAY:
            alert("INFO");           			
			alert( document.getElementById('infoList').innerHTML);
			break; 			
		*/
			
        case tvKey.KEY_STOP:
			if(Main.yandextv_mode)
				Main.DisableGone();
			else
				Search.setFormular();
				alert( document.body.innerHTML);
			break;
			
		case tvKey.KEY_FF:
			if(Main.yandextv_mode)
			{
				API.yandex_days = API.yandex_days + 1;
				Main.yandexTVinfo();
			}

            break;
        
        case tvKey.KEY_RW:
			if(Main.yandextv_mode)
			{
				API.yandex_days = API.yandex_days - 1;
				Main.yandexTVinfo();
			}
            break;

		case 65://KEY_CH_DOWN
			if(Main.yandextv_mode)
			{
				Main.scrolling = Main.scrolling + 10;
				var test = document.getElementsByClassName("b-schedule__channel")[0];
				//alert('test 1' + test);
				test.style.margin = Main.scrolling + 'px 0px 0px 0px';
				//alert('Main.scrolling ' + Main.scrolling);
				//document.frames['yandex_tv'].document.getElementsByClassName("h-search")[0].style.display = 'true';	
			}
            break;		 
		 
		case 68://KEY_CH_UP
			if(Main.yandextv_mode)
			{
				Main.scrolling = Main.scrolling - 10;
				var test =  document.getElementsByClassName("b-schedule__channel")[0];
				//alert('test 1' + test);
				test.style.margin = Main.scrolling + 'px 0px 0px 0px';
				//alert('Main.scrolling ' + Main.scrolling);
				//document.frames['yandex_tv'].document.getElementsByClassName("h-search")[0].style.display = 'true';	
			}
            break;	
			
		case tvKey.KEY_PLAY:
			if(Main.yandextv_mode)
			{          			
			alert( document.getElementById('infoList').innerHTML);
			}
			break; 		

		case tvKey.KEY_PAUSE:
			if(Main.yandextv_mode)
			{          			
				Main.yandexTVinfo();
			}
			break;
		
		case tvKey.KEY_BLUE:
			Main.showPlaylistSelector();
			Selectbox.mode = 1;
			break;
			
		default:
            alert("Unhandled key");
            break;
    }
}	


KeyHandler.SelectboxKeyDown = function()
{

	var keyCode5 = event.keyCode;
	alert("SelectboxKeyDown Key pressed: " + keyCode5);
			
	switch(keyCode5)
    {
		case tvKey.KEY_DOWN:;
            Selectbox.selectNextItem();
            break;
            
        case tvKey.KEY_UP:
			Selectbox.selectPrevItem();
            break;            
			
        case tvKey.KEY_ENTER:
			if(Selectbox.mode == 0)
				Selectbox.SelectCategory();
			else
				Selectbox.SelectPlaylist();
            break;

		case tvKey.KEY_LEFT:;
            Selectbox.selectPrevPage();
            break;
            
        case tvKey.KEY_RIGHT:
			Selectbox.selectNextPage();
            break;
			
	    case tvKey.KEY_EXIT:
		case tvKey.KEY_RETURN:
			widgetAPI.blockNavigation(event);
			Selectbox.selectbox_html.style.display="none";
			KeyHandler.setFocus(Main.MainMenu_ID);
            break;
			break;
			
		default:
            alert("Unhandled key");
            break;
	}

}

KeyHandler.LivePlayerKeyDown = function()
{
	var keyCode1 = event.keyCode;
	alert("LivePlayerKeyDown Key pressed: " + keyCode1);
	KeyHandler.Keys10(keyCode1);	
	
	switch(keyCode1)
    {			
		case 1219://KEY_3D
			Screen.changeMode();
			break;
			
		case tvKey.KEY_BLUE:
		widgetAPI.blockNavigation(event);
            if (Screen.getModeD()>=2)
                Screen.changeModeD(0);
			else
				Screen.changeModeD(Screen.getModeD()+1);
            break;

		case tvKey.KEY_RED:
		widgetAPI.blockNavigation(event);
            if (Screen.getModeD2()>=2)
                Screen.changeModeD2(0);
			else
				Screen.changeModeD2(Screen.getModeD2()+1);
            break;
			
		case tvKey.KEY_REC:
			Player.matrixReload();
			break;
			
		case 653://KEY_ASPECT
            if (Player.getSize()>=2)
                Player.setSize(0, 1);
			else
				Player.setSize(Player.getSize()+1, 1);
            break;
 
		 case tvKey.KEY_LEFT:
		 case 65://KEY_CH_DOWN
            Main.selectPrevChannel();
			Main.PlayChannel();
            break;
            
        case tvKey.KEY_RIGHT:
		case 68://KEY_CH_UP
            Main.selectNextChannel();
			Main.PlayChannel();
            break;            

        case tvKey.KEY_ENTER:
			if(	Main.StreamMode == "rtmp" && Main.serieC)
			{
				Main.player.info(API.channels[Main.chan_array_index][1]);
			}
			Display.showplayer();
            break;
			
        case tvKey.KEY_VOL_UP:
            Audio.setRelativeVolume(0);
			Display.setVolume();
			if(	Main.StreamMode == "rtmp" && Main.serieC)
				Main.player.set_text("Volume: " + Audio.getVolume());
            break;
            
        case tvKey.KEY_VOL_DOWN:
            Audio.setRelativeVolume(1);
			if(	Main.StreamMode == "rtmp" && Main.serieC)
				Main.player.set_text("Volume: " + Audio.getVolume());
			Display.setVolume();
            break; 				

	    case tvKey.KEY_RETURN:
		case tvKey.KEY_EXIT:
			widgetAPI.blockNavigation(event);

			if(	Main.StreamMode == "rtmp" && Main.serieC)
			{
				document.getElementById("flashplayer").style.display="none";
				document.getElementById("main").style.display="block";
				widgetAPI.putInnerHTML(document.getElementById("flashplayer"), "");
			}
			Display.hideplayer();
            Display.showmenu();
			Main.Menu();
			break;

			
		case tvKey.KEY_MUTE:
			Audio.muteMode();
            break;
			
		case tvKey.KEY_GREEN:
            pluginAPI.ShowTools(1);
            break;
 
		case tvKey.KEY_YELLOW:
			pluginAPI.ShowTools(0);
            break;

		case tvKey.KEY_STOP:
			if(this.black_line)
			{
				document.getElementById("black_line_top").style.display="none";	
				this.black_line = false;
			}
			else
			{
				document.getElementById("black_line_top").style.display="block";
				this.black_line = true;
			}
			break;
			
		default:
            alert("Unhandled key");
            break;
	}
}

KeyHandler.VideothekPlayerKeyDown = function() //PLAYER
{

	var keyCode5 = event.keyCode;
	alert("Key pressed: " + keyCode5);
			
	switch(keyCode5)
    {
		case 1219://KEY_3D
			Screen.changeMode();
			break;
			
		case tvKey.KEY_BLUE:
		widgetAPI.blockNavigation(event);
            if (Screen.getModeD()>=2)
                Screen.changeModeD(0);
			else
				Screen.changeModeD(Screen.getModeD()+1);
            break;

		case tvKey.KEY_RED:
		widgetAPI.blockNavigation(event);
            if (Screen.getModeD2()>=2)
                Screen.changeModeD2(0);
			else
				Screen.changeModeD2(Screen.getModeD2()+1);
            break;

		case tvKey.KEY_RETURN:
		case tvKey.KEY_EXIT:
			widgetAPI.blockNavigation(event);
			Display.hideplayer();
            Display.showmenu();
			Main.Menu();
			break;

		 case tvKey.KEY_LEFT:
			Player.MinutesJump(-1);
            break;
            
        case tvKey.KEY_RIGHT:
			Player.MinutesJump(1);
            break; 
			
		case tvKey.KEY_DOWN:	
			Player.MinutesJump(-5);
            break;
			
		case tvKey.KEY_UP:
			Player.MinutesJump(5);
            break;
/*
        case tvKey.KEY_FF:
            Player.MinutesJump(10);
            break;
        
        case tvKey.KEY_RW:
            Player.MinutesJump(-10);
            break;
*/
		 case tvKey.KEY_RW:
            Main.selectPrevChannel();
			Main.PlayChannel();
            break;
            
        case tvKey.KEY_FF:
            Main.selectNextChannel();
			Main.PlayChannel();
            break; 
			
        case tvKey.KEY_ENTER:
			Display.showplayer();
            break;

		case tvKey.KEY_PLAY:
			Player.resumeVideo();
            break;
            
         case tvKey.KEY_PAUSE:
			Player.pauseVideo();
			break;

        case tvKey.KEY_STOP:
			//
			break;
			
	    case tvKey.KEY_0:
			Player.PercentJump(0);
			Display.status("0%");
			break;
			
	    case tvKey.KEY_1:
			Player.PercentJump(1);
			break;
			
	    case tvKey.KEY_2:
			Player.PercentJump(2);
			break;
			
	    case tvKey.KEY_3:
			Player.PercentJump(3);
			break;
			
	    case tvKey.KEY_4:
			Player.PercentJump(4);
			break;
			
	    case tvKey.KEY_5:
			Player.PercentJump(5);
			break;
			
	    case tvKey.KEY_6:
			Player.PercentJump(6);
			break;
			
	    case tvKey.KEY_7:
			Player.PercentJump(7);
			break;
			
	    case tvKey.KEY_8:
			Player.PercentJump(8);
			break;
			
	    case tvKey.KEY_9:
			Player.PercentJump(9);
			break;

		case tvKey.KEY_TOOLS://VideothekPlayer
            pluginAPI.ShowTools(1);
            break;
			
		case tvKey.KEY_YELLOW:
            pluginAPI.ShowTools(0);
            break;
			
		case 653://KEY_ASPECT
		case 1086: //BD DISC MENU
		case 1249:// FULL SCREEN  BD
            if (Player.getSize()>=3)
                Player.setSize(0, 1);
			else
				Player.setSize(Player.getSize()+1, 1);
            break;
			
        case tvKey.KEY_VOL_UP:
            Audio.setRelativeVolume(0);
			Display.setVolume();
            break;
            
        case tvKey.KEY_VOL_DOWN:
            Audio.setRelativeVolume(1);
			Display.setVolume();
            break;
			
		case tvKey.KEY_EXIT:
			widgetAPI.blockNavigation(event);    
            break;
			
		case tvKey.KEY_MUTE:
			Audio.muteMode();
            break;		
			
		default:
            alert("Unhandled key");
            break;
	}
}
KeyHandler.BrowserKeyDown = function()
{

	var keyCode6 = event.keyCode;
	alert("BrowserKeyDown Key pressed: " + keyCode6);
			
	switch(keyCode6)
    {
/*
		case tvKey.KEY_DOWN:;
            Selectbox.selectNextItem();
            break;
            
        case tvKey.KEY_UP:
			Selectbox.selectPrevItem();
            break;            
			
        case tvKey.KEY_ENTER:
			Selectbox.SelectCategory();
            break;

		case tvKey.KEY_LEFT:;
            Selectbox.selectPrevPage();
            break;
            
        case tvKey.KEY_RIGHT:
			Selectbox.selectNextPage();
            break;
*/			

		case tvKey.KEY_INFO:
			KeyHandler.setFocus(Main.MainMenu_ID);
			var browser = document.getElementById("browser");
			widgetAPI.putInnerHTML(browser, '');
			browser.style.display="none";
			document.getElementById("mainbody").style.width= "960px";
			document.getElementById("mainbody").style.height= "540px";
			document.getElementById("main").style.display="block";
			Main.Menu();
            break;


	    case tvKey.KEY_EXIT:
			widgetAPI.blockNavigation(event);
			location.reload(true);
            break;
			
		case tvKey.KEY_RETURN:
			widgetAPI.blockNavigation(event);
			if(this.browser_last_selected_url!="")
				document.getElementById('website_url').src = Main.browser_last_selected_url;
			else
				location.reload(true);
			break;
		 
        case tvKey.KEY_ENTER:
			var url = '';
			if(Main.browser_selected_url.indexOf("://")>0)
				url = Main.browser_selected_url;
			else
				url = Main.document_location_href + Main.browser_selected_url;
			document.getElementById('website_url').src = url;
            break
			
        case tvKey.KEY_RIGHT:
            Main.browserNextHref();
            break;
        
        case tvKey.KEY_LEFT:
            Main.browserPrevHref();
            break;
			
        case tvKey.KEY_STOP:
            Main.browserHrefs();
            break;
				
		default:
            alert("BrowserKeyDown Unhandled key");
            break;
	}

}
